<?php

// Check if they set a username / password
if(isset($_POST['username'])) {
	$_SESSION['username'] = $_POST['username'];
}
if(isset($_POST['password'])) {
	$_SESSION['password'] = $_POST['password'];
}

$globals['siteId'] = -1;
$globals['isAdmin'] = 0;

// Make sure they are logged in
if(isset($_SESSION['username']) && isset($_SESSION['password'])) {
	$st = $db->prepare("SELECT * FROM contest_users WHERE username = :username AND password = :password");
	$st->execute(array(':username' => $_SESSION['username'], ':password' => $_SESSION['password']));
	// Check the results
	$results = $st->fetchAll();
	// Check if there were rows
	if(count($results)) {
		$globals['siteId'] = $results[0]['sid'];
		$globals['isAdmin'] = $results[0]['isAdmin'];
		echo "You are logged in (Site=" . $globals['siteId'] . "/admin=" . $globals['isAdmin'] . ") <a href=\"./logout.php\">Logout</a>";
	} else {
		// Not logged in
		die("Invalid username/password See <a href=\"./login.php\">Login</a> again");
	}
} else {
	die("Not logged in.  See <a href=\"./login.php\">Login</a>");
}

// Given a team id, will return their site id.  If it is unknown, it will return -1
function getTeamSiteId($db, $tid) {
	$st = $db->prepare("SELECT sid FROM contest_teams WHERE tid = ?");
	$st->execute(array($tid));
	$results = $st->fetchAll();
	if(count($results)) {
		return $results[0]['sid'];
	}
	return -1;
}

// Given a team id, will return their site start time.  If it is unknown, it will return 00:00:00
function getTeamStartTime($db, $tid) {
	$st = $db->prepare("SELECT sites.startTime startTime FROM contest_teams teams LEFT JOIN contest_sites sites ON (teams.sid = sites.sid) WHERE teams.tid = ?");
	$st->execute(array($tid));
	$results = $st->fetchAll();
	if(count($results)) {
		return strtotime($results[0]['startTime']);
	}
	return strtotime("00:00:00");
}

// Given a result id, will return their team id ('tid') and site id ('sid').  If it is unknown, i twill return -1
function getResultTeamSiteId($db, $rid) {
	$returnVal['tid'] = -1;
	$returnVal['sid'] = -1;
	$st = $db->prepare("SELECT results.tid tid, teams.sid sid FROM contest_results results LEFT JOIN contest_teams teams ON results.tid = teams.tid WHERE rid = ?");
	$st->execute(array($rid));
	$results = $st->fetchAll();
	if(count($results)) {
		$returnVal['tid'] = $results[0]['tid'];
		$returnVal['sid'] = $results[0]['sid'];
	}
	return $returnVal;
}

?>
