<?php

header('Refresh: 1; URL=./admin.php');

require_once('header.php');
require_once('admin_header.php');

// Handles all the updates to the database

// Add users
if(isset($_POST['addUser']) && $globals['isAdmin'] == 1) {
	$userLogin = "";
	$userPassword = "";
	$userSid = "";
	if($_POST['userLogin']) { $userLogin = $_POST['userLogin']; }
	if($_POST['userPassword']) { $userPassword = $_POST['userPassword']; }
	if($_POST['userSid']) { $userSid = $_POST['userSid']; }
	if(!empty($userLogin) && !empty($userPassword)) {
		$st = $db->prepare("INSERT INTO contest_users (username, password, sid) VALUES (?,?,?)");
		$st->execute(array($userLogin, $userPassword, $userSid));
		if($db->lastInsertId()) {
			echo "Inserted a user " . $db->lastInsertId();
		}
	} else {
		echo "Not valid userLogin ($userLogin), userPassword ($userPassword), or userSid ($userSid)";
	}
}
// Adds sites
if(isset($_POST['addSite']) && $globals['isAdmin'] == 1) {
	$siteName = "";
	if($_POST['siteName']) { $siteName = $_POST['siteName']; }
	if(!empty($siteName)) {
		$st = $db->prepare("INSERT INTO contest_sites (name) VALUES (?)");
		$st->execute(array($siteName));
		if($db->lastInsertId()) {
			echo "Inserted a site" . $db->lastInsertId();
		}
	} else {
		echo "Not valid siteName ($siteName)";
	}
}
// Update sites
if(isset($_POST['updateSite'])) {
	$sid = "";
	$siteName = "";
	$startTime = "";
	if($_POST['sid']) { $sid = $_POST['sid']; }
	if($_POST['siteName']) { $siteName = $_POST['siteName']; }
	if($_POST['startTime']) { $startTime = $_POST['startTime']; }
	if(!empty($sid) && !empty($siteName)) {
		if($globals['isAdmin'] != 1 && $sid != $globals['siteId']) {
			echo "You cannot update someone elses site.  Sorry";
		} else {
			$st = $db->prepare("UPDATE contest_sites SET name=?, startTime=? WHERE sid=?");
			$st->execute(array($siteName, $startTime, $sid));
			if($db->lastInsertId()) {
				echo "Updated a site" . $db->lastInsertId();
			}
		}
	} else {
		echo "Not valid siteName ($siteName)";
	}
}
// Adds teams
if(isset($_POST['addTeam'])) {
	$teamSid = "";
	$teamName = "";
	$reservationId = "";
	$instituteName = "";
	if($_POST['teamName']) { $teamName = $_POST['teamName']; }
	if($_POST['teamSid']) { $teamSid = $_POST['teamSid']; }
	if($_POST['reservationId']) { $reservationId = $_POST['reservationId']; }
	if($_POST['instituteName']) { $instituteName = $_POST['instituteName']; }
	if(!empty($teamSid) && !empty($teamName)) {
		if($globals['isAdmin'] != 1 && $teamSid != $globals['siteId']) {
			echo "You cannot update someone elses site.  Sorry";
		} else {
			$st = $db->prepare("INSERT INTO contest_teams (sid, name) VALUES (?,?,?,?)");
			$st->execute(array($teamSid, $teamName, $reservationId, $instituteName));
			if($db->lastInsertId()) {
				echo $db->lastInsertId();
			}
		}
	} else {
		echo "Not valid teamSid ($teamSid), or teamName ($teamName)";
	}
}
// Update teams
if(isset($_POST['updateTeam'])) {
	$teamTid = "";
	$teamName = "";
	$reservationId = "";
	$instituteName = "";
	if($_POST['teamTid']) { $teamTid = $_POST['teamTid']; }
	if($_POST['teamName']) { $teamName = $_POST['teamName']; }
	if($_POST['reservationId']) { $reservationId = $_POST['reservationId']; }
	if($_POST['instituteName']) { $instituteName = $_POST['instituteName']; }
	if(!empty($teamTid) && !empty($teamName)) {
		if($globals['isAdmin'] != 1 && getTeamSiteId($db, $teamTid) != $globals['siteId']) {
			echo "You cannot update someone elses site.  Sorry";
		} else {
			$st = $db->prepare("UPDATE contest_teams SET name=?, reservationId=?, instituteName=? WHERE tid=?");
			$st->execute(array($teamName, $reservationId, $instituteName, $teamTid));
			if($db->lastInsertId()) {
				echo "Updated a team" . $db->lastInsertId();
			}
		}
	} else {
		echo "Not valid teamID ($teamTid), name ($teamName)";
	}
}
// Removes teams
if(isset($_POST['deleteTeam'])) {
	$teamTid = "";
	if($_POST['teamTid']) { $teamTid = $_POST['teamTid']; }
	if(!empty($teamTid)) {
		if($globals['isAdmin'] != 1) {
			echo "You must be an admin.  Sorry";
		} else {
			$st = $db->prepare("DELETE FROM contest_teams WHERE tid=?");
			$st->execute(array($teamTid));
			$st = $db->prepare("DELETE FROM contest_results WHERE tid=?");
			$st->execute(array($teamTid));
		}
	} else {
		echo "Not valid teamTid ($teamTid)";
	}
}
// Update results
if(isset($_POST['updateResult'])) {
	$resultRid = array();
	$resultSid = "";
	$resultTid = "";
	$resultsPid = array();
	$resultAttempts = array();
	$resultAttempts_org = array();
	$resultTime = array();
	$resultTime_org = array();
	if($_POST['rid']) { $resultRid = $_POST['rid']; }
	if($_POST['sid']) { $resultSid = $_POST['sid']; }
	if($_POST['tid']) { $resultTid = $_POST['tid']; }
	if($_POST['pid']) { $resultPid = $_POST['pid']; }
	if($_POST['attempts']) { $resultAttempts = $_POST['attempts']; }
	if($_POST['attempts_org']) { $resultAttempts_org = $_POST['attempts_org']; }
	if($_POST['time']) { $resultTime = $_POST['time']; }
	if($_POST['time_org']) { $resultTime_org = $_POST['time_org']; }
	if(!empty($resultSid) && !empty($resultTid) && !empty($resultPid) && !empty($resultAttempts) && !empty($resultAttempts_org) && !empty($resultTime) && !empty($resultTime_org)) {
		if($globals['isAdmin'] != 1 && getTeamSiteId($db, $resultTid) != $globals['siteId']) {
			echo "You cannot update someone elses site.  Sorry";
		} else {
			for($i = 0; $i < sizeof($resultRid); $i++) {
				// The old way of doing it, before keeping the history
				/*
				if(!empty($resultRid[$i])) {
					// If the result is set, verify that the teamid and siteid are set correctly
					$resultTeamSiteId = getResultTeamSiteId($db, $resultRid[$i]);
					if($resultTeamSiteId['tid'] != $resultTid) {
						echo "Team id not set correct on result\n";
						continue;
					}
					if($resultTeamSiteId['sid'] != $resultSid) {
						echo "Site id not set correct on result\n";
						continue;
					}
				}
				*/
				// Format the time.  If it has a colon, figure out the difference in time
				if(strpos($resultTime[$i], ':')) {
					$resultTime[$i] = strtotime($resultTime[$i]);
					$teamStartTime = getTeamStartTime($db, $resultTid);
					if($resultTime[$i] > $teamStartTime) {
						// The difference in time will be in seconds, convert to minutes
						$resultTime[$i] = ($resultTime[$i] - $teamStartTime)/60;
					} else {
						// Add 12 hours, then do difference
						$resultTime[$i] = (($resultTime[$i]+60*60*12) - $teamStartTime)/60;
					}
				}
				// Default the time to 0
				if(empty($resultTime[$i])) {
					$resultTime[$i] = 0;
				}
				// Update results, only if we have attempts, or there has been a change
				if(!empty($resultAttempts[$i]) && ($resultAttempts[$i] != $resultAttempts_org[$i]) || $resultTime[$i] != $resultTime_org[$i]) {
					// If there is no result id, insert a new role
					/*
					if(empty($resultRid[$i])) {
						$st = $db->prepare("INSERT INTO contest_results (tid, pid, attempts, time) VALUES (?,?,?,?)");
						$st->execute(array($resultTid, $resultPid[$i], $resultAttempts[$i], $resultTime[$i]));
						if($db->lastInsertId()) {
							echo $db->lastInsertId();
							$insertId = $db->lastInsertId();
							// Get the number of rows for this tid, if greater, delete this (because we only want 1 row for each (tid,pid)
							$st = $db->prepare("SELECT COUNT(*) count FROM contest_results WHERE tid = ? AND pid = ?");
							$st->execute(array($resultTid, $resultPid[$i]));
							$countResults = $st->fetchAll();
							if(count($countResults)) {
								// If there is more than 1 result, we have to many
								if($countResults[0]['count'] > 1) {
									echo "Result already existed...\n";
									$st = $db->prepare("DELETE FROM contest_results WHERE rid=?");
									$st->execute(array($insertId));
								}
							}
						}
					// If there is a result id, do an update
					} else {
						$st = $db->prepare("UPDATE contest_results SET attempts=?, time=? WHERE rid=?");
						$st->execute(array($resultAttempts[$i], $resultTime[$i], $resultRid[$i]));
						if($db->lastInsertId()) {
							echo $db->lastInsertId();
						}
					}
					*/
					$st = $db->prepare("INSERT INTO contest_results (tid, pid, attempts, time) VALUES (?,?,?,?)");
					$st->execute(array($resultTid, $resultPid[$i], $resultAttempts[$i], $resultTime[$i]));
					if($db->lastInsertId()) {
						echo $db->lastInsertId();
					}
				// Delete results
				} else if(empty($resultAttempts[$i]) && empty($resultTime[$i])) {
					if(!empty($resultRid[$i])) {
						$st = $db->prepare("DELETE FROM contest_results WHERE rid=?");
						$st->execute(array($resultRid[$i]));
						echo "Deleted the result $resultRid[$i]";
					} else {
						// Record does not exist if result id is not set
						// echo "No record";
					}
				}
			}
		}
	} else {
		echo "Not valid sid ($resultSid) tid ($resultTid) pid ($resultPid) attempts ($resultAttempts) time ($resultTime)";
	}
}

?>
<p>
<a href="./admin.php">Redirecting you back in 1 second, otherwise click here...</a>
</p>
